/// @cond EO_CXX_EO_IMPL

inline bool elm_interface_fileselector::custom_filter_append(Elm_Fileselector_Filter_Func func_, void * data_, ::efl::eina::string_view filter_name_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_custom_filter_append(func_, data_, ::efl::eolian::to_c(filter_name_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm_interface_fileselector::filters_clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_filters_clear());
}

inline bool elm_interface_fileselector::mime_types_filter_append(::efl::eina::string_view mime_types_, ::efl::eina::string_view filter_name_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_mime_types_filter_append(::efl::eolian::to_c(mime_types_), ::efl::eolian::to_c(filter_name_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm_interface_fileselector::folder_only_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_folder_only_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm_interface_fileselector::folder_only_set(bool only_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_folder_only_set(::efl::eolian::to_c(only_)));
}

inline ::efl::eina::string_view elm_interface_fileselector::selected_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_selected_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm_interface_fileselector::selected_set(::efl::eina::string_view path_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_selected_set(::efl::eolian::to_c(path_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm_interface_fileselector::thumbnail_size_get(Evas_Coord* w_, Evas_Coord* h_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_thumbnail_size_get(w_, h_));
}

inline void elm_interface_fileselector::thumbnail_size_set(Evas_Coord w_, Evas_Coord h_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_thumbnail_size_set(w_, h_));
}

inline bool elm_interface_fileselector::hidden_visible_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_hidden_visible_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm_interface_fileselector::hidden_visible_set(bool multi_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_hidden_visible_set(::efl::eolian::to_c(multi_)));
}

inline Elm_Fileselector_Sort elm_interface_fileselector::sort_method_get() const
{
   Elm_Fileselector_Sort _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_sort_method_get());
   return _tmp_ret;
}

inline void elm_interface_fileselector::sort_method_set(Elm_Fileselector_Sort sort_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_sort_method_set(sort_));
}

inline bool elm_interface_fileselector::multi_select_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_multi_select_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm_interface_fileselector::multi_select_set(bool multi_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_multi_select_set(::efl::eolian::to_c(multi_)));
}

inline bool elm_interface_fileselector::expandable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_expandable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm_interface_fileselector::expandable_set(bool expand_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_expandable_set(::efl::eolian::to_c(expand_)));
}

inline ::efl::eina::string_view elm_interface_fileselector::path_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_path_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm_interface_fileselector::path_set(::efl::eina::string_view path_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_path_set(::efl::eolian::to_c(path_)));
}

inline Elm_Fileselector_Mode elm_interface_fileselector::mode_get() const
{
   Elm_Fileselector_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_mode_get());
   return _tmp_ret;
}

inline void elm_interface_fileselector::mode_set(Elm_Fileselector_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_mode_set(mode_));
}

inline bool elm_interface_fileselector::is_save_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_is_save_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm_interface_fileselector::is_save_set(bool is_save_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_is_save_set(::efl::eolian::to_c(is_save_)));
}

inline ::efl::eina::crange_list< ::efl::eina::string_view > elm_interface_fileselector::selected_paths_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_selected_paths_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline ::efl::eina::string_view elm_interface_fileselector::current_name_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_current_name_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm_interface_fileselector::current_name_set(::efl::eina::string_view name_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_current_name_set(::efl::eolian::to_c(name_)));
}

inline bool eo_cxx::elm_interface_fileselector::custom_filter_append(Elm_Fileselector_Filter_Func func_, void * data_, ::efl::eina::string_view filter_name_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_custom_filter_append(func_, data_, ::efl::eolian::to_c(filter_name_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm_interface_fileselector::filters_clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_filters_clear());
}

inline bool eo_cxx::elm_interface_fileselector::mime_types_filter_append(::efl::eina::string_view mime_types_, ::efl::eina::string_view filter_name_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_mime_types_filter_append(::efl::eolian::to_c(mime_types_), ::efl::eolian::to_c(filter_name_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm_interface_fileselector::folder_only_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_folder_only_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm_interface_fileselector::folder_only_set(bool only_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_folder_only_set(::efl::eolian::to_c(only_)));
}

inline ::efl::eina::string_view eo_cxx::elm_interface_fileselector::selected_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_selected_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm_interface_fileselector::selected_set(::efl::eina::string_view path_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_selected_set(::efl::eolian::to_c(path_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm_interface_fileselector::thumbnail_size_get(Evas_Coord* w_, Evas_Coord* h_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_thumbnail_size_get(w_, h_));
}

inline void eo_cxx::elm_interface_fileselector::thumbnail_size_set(Evas_Coord w_, Evas_Coord h_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_thumbnail_size_set(w_, h_));
}

inline bool eo_cxx::elm_interface_fileselector::hidden_visible_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_hidden_visible_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm_interface_fileselector::hidden_visible_set(bool multi_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_hidden_visible_set(::efl::eolian::to_c(multi_)));
}

inline Elm_Fileselector_Sort eo_cxx::elm_interface_fileselector::sort_method_get() const
{
   Elm_Fileselector_Sort _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_sort_method_get());
   return _tmp_ret;
}

inline void eo_cxx::elm_interface_fileselector::sort_method_set(Elm_Fileselector_Sort sort_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_sort_method_set(sort_));
}

inline bool eo_cxx::elm_interface_fileselector::multi_select_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_multi_select_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm_interface_fileselector::multi_select_set(bool multi_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_multi_select_set(::efl::eolian::to_c(multi_)));
}

inline bool eo_cxx::elm_interface_fileselector::expandable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_expandable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm_interface_fileselector::expandable_set(bool expand_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_expandable_set(::efl::eolian::to_c(expand_)));
}

inline ::efl::eina::string_view eo_cxx::elm_interface_fileselector::path_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_path_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm_interface_fileselector::path_set(::efl::eina::string_view path_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_path_set(::efl::eolian::to_c(path_)));
}

inline Elm_Fileselector_Mode eo_cxx::elm_interface_fileselector::mode_get() const
{
   Elm_Fileselector_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_mode_get());
   return _tmp_ret;
}

inline void eo_cxx::elm_interface_fileselector::mode_set(Elm_Fileselector_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_mode_set(mode_));
}

inline bool eo_cxx::elm_interface_fileselector::is_save_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_is_save_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm_interface_fileselector::is_save_set(bool is_save_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_is_save_set(::efl::eolian::to_c(is_save_)));
}

inline ::efl::eina::crange_list< ::efl::eina::string_view > eo_cxx::elm_interface_fileselector::selected_paths_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_selected_paths_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline ::efl::eina::string_view eo_cxx::elm_interface_fileselector::current_name_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_current_name_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm_interface_fileselector::current_name_set(::efl::eina::string_view name_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_fileselector_current_name_set(::efl::eolian::to_c(name_)));
}

inline ::eo_cxx::elm_interface_fileselector::operator ::elm_interface_fileselector() const
{
   return *static_cast<::elm_interface_fileselector const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm_interface_fileselector::operator ::elm_interface_fileselector&()
{
   return *static_cast<::elm_interface_fileselector*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm_interface_fileselector::operator ::elm_interface_fileselector const&() const
{
   return *static_cast<::elm_interface_fileselector const*>(static_cast<void const*>(this));
}

template <typename T>
bool _elm_interface_fileselector_custom_filter_append_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Fileselector_Filter_Func func_, void * data_, const char * filter_name_)
{
   try
      {
         return static_cast<T*>(self->this_)->custom_filter_append(func_, data_, ::efl::eolian::to_cxx<::efl::eina::string_view>(filter_name_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void _elm_interface_fileselector_filters_clear_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->filters_clear();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _elm_interface_fileselector_mime_types_filter_append_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * mime_types_, const char * filter_name_)
{
   try
      {
         return static_cast<T*>(self->this_)->mime_types_filter_append(::efl::eolian::to_cxx<::efl::eina::string_view>(mime_types_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::string_view>(filter_name_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool _elm_interface_fileselector_folder_only_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->folder_only_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void _elm_interface_fileselector_folder_only_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool only_)
{
   try
      {
         static_cast<T*>(self->this_)->folder_only_set(::efl::eolian::to_cxx<bool>(only_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::string_view _elm_interface_fileselector_selected_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->selected_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool _elm_interface_fileselector_selected_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * path_)
{
   try
      {
         return static_cast<T*>(self->this_)->selected_set(::efl::eolian::to_cxx<::efl::eina::string_view>(path_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void _elm_interface_fileselector_thumbnail_size_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* w_, Evas_Coord* h_)
{
   try
      {
         static_cast<T*>(self->this_)->thumbnail_size_get(w_, h_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _elm_interface_fileselector_thumbnail_size_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Coord w_, Evas_Coord h_)
{
   try
      {
         static_cast<T*>(self->this_)->thumbnail_size_set(w_, h_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _elm_interface_fileselector_hidden_visible_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->hidden_visible_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void _elm_interface_fileselector_hidden_visible_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool multi_)
{
   try
      {
         static_cast<T*>(self->this_)->hidden_visible_set(::efl::eolian::to_cxx<bool>(multi_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Fileselector_Sort _elm_interface_fileselector_sort_method_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->sort_method_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Fileselector_Sort _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void _elm_interface_fileselector_sort_method_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Fileselector_Sort sort_)
{
   try
      {
         static_cast<T*>(self->this_)->sort_method_set(sort_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _elm_interface_fileselector_multi_select_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->multi_select_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void _elm_interface_fileselector_multi_select_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool multi_)
{
   try
      {
         static_cast<T*>(self->this_)->multi_select_set(::efl::eolian::to_cxx<bool>(multi_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _elm_interface_fileselector_expandable_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->expandable_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void _elm_interface_fileselector_expandable_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool expand_)
{
   try
      {
         static_cast<T*>(self->this_)->expandable_set(::efl::eolian::to_cxx<bool>(expand_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::string_view _elm_interface_fileselector_path_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->path_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void _elm_interface_fileselector_path_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * path_)
{
   try
      {
         static_cast<T*>(self->this_)->path_set(::efl::eolian::to_cxx<::efl::eina::string_view>(path_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Fileselector_Mode _elm_interface_fileselector_mode_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->mode_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Fileselector_Mode _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void _elm_interface_fileselector_mode_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Fileselector_Mode mode_)
{
   try
      {
         static_cast<T*>(self->this_)->mode_set(mode_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _elm_interface_fileselector_is_save_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->is_save_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void _elm_interface_fileselector_is_save_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool is_save_)
{
   try
      {
         static_cast<T*>(self->this_)->is_save_set(::efl::eolian::to_cxx<bool>(is_save_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::crange_list< ::efl::eina::string_view > _elm_interface_fileselector_selected_paths_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->selected_paths_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const Eina_List * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }
}

template <typename T>
::efl::eina::string_view _elm_interface_fileselector_current_name_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->current_name_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void _elm_interface_fileselector_current_name_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * name_)
{
   try
      {
         static_cast<T*>(self->this_)->current_name_set(::efl::eolian::to_cxx<::efl::eina::string_view>(name_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_interface_fileselector >
{
   template <typename T>
   struct type
   {
      virtual bool custom_filter_append(Elm_Fileselector_Filter_Func func_, void * data_, ::efl::eina::string_view filter_name_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_custom_filter_append(func_, data_, ::efl::eolian::to_c(filter_name_)));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void filters_clear()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_filters_clear());
      }

      virtual bool mime_types_filter_append(::efl::eina::string_view mime_types_, ::efl::eina::string_view filter_name_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_mime_types_filter_append(::efl::eolian::to_c(mime_types_), ::efl::eolian::to_c(filter_name_)));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool folder_only_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_folder_only_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void folder_only_set(bool only_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_folder_only_set(::efl::eolian::to_c(only_)));
      }

      virtual ::efl::eina::string_view selected_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_selected_get());
            return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool selected_set(::efl::eina::string_view path_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_selected_set(::efl::eolian::to_c(path_)));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void thumbnail_size_get(Evas_Coord* w_, Evas_Coord* h_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_thumbnail_size_get(w_, h_));
      }

      virtual void thumbnail_size_set(Evas_Coord w_, Evas_Coord h_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_thumbnail_size_set(w_, h_));
      }

      virtual bool hidden_visible_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_hidden_visible_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void hidden_visible_set(bool multi_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_hidden_visible_set(::efl::eolian::to_c(multi_)));
      }

      virtual Elm_Fileselector_Sort sort_method_get()
      {
         Elm_Fileselector_Sort _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_sort_method_get());
            return _tmp_ret;
      }

      virtual void sort_method_set(Elm_Fileselector_Sort sort_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_sort_method_set(sort_));
      }

      virtual bool multi_select_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_multi_select_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void multi_select_set(bool multi_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_multi_select_set(::efl::eolian::to_c(multi_)));
      }

      virtual bool expandable_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_expandable_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void expandable_set(bool expand_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_expandable_set(::efl::eolian::to_c(expand_)));
      }

      virtual ::efl::eina::string_view path_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_path_get());
            return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void path_set(::efl::eina::string_view path_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_path_set(::efl::eolian::to_c(path_)));
      }

      virtual Elm_Fileselector_Mode mode_get()
      {
         Elm_Fileselector_Mode _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_mode_get());
            return _tmp_ret;
      }

      virtual void mode_set(Elm_Fileselector_Mode mode_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_mode_set(mode_));
      }

      virtual bool is_save_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_is_save_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void is_save_set(bool is_save_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_is_save_set(::efl::eolian::to_c(is_save_)));
      }

      virtual ::efl::eina::crange_list< ::efl::eina::string_view > selected_paths_get()
      {
         const Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_selected_paths_get());
            return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

      virtual ::efl::eina::string_view current_name_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_current_name_get());
            return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void current_name_set(::efl::eina::string_view name_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_current_name_set(::efl::eolian::to_c(name_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_interface_fileselector >
{
   static constexpr int value = 
#if defined(ELM_INTERFACE_FILESELECTOR_PROTECTED) && defined(ELM_INTERFACE_FILESELECTOR_BETA)
      26
#elif defined(ELM_INTERFACE_FILESELECTOR_PROTECTED)
      26
#elif defined(ELM_INTERFACE_FILESELECTOR_BETA)
      26
#else
      26
#endif
;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm_interface_fileselector>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_custom_filter_append_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_custom_filter_append);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_filters_clear_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_filters_clear);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_mime_types_filter_append_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_mime_types_filter_append);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_folder_only_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_folder_only_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_folder_only_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_folder_only_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_selected_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_selected_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_selected_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_selected_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_thumbnail_size_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_thumbnail_size_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_thumbnail_size_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_thumbnail_size_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_hidden_visible_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_hidden_visible_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_hidden_visible_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_hidden_visible_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_sort_method_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_sort_method_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_sort_method_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_sort_method_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_multi_select_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_multi_select_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_multi_select_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_multi_select_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_expandable_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_expandable_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_expandable_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_expandable_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_path_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_path_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_path_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_path_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_mode_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_mode_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_mode_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_mode_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_is_save_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_is_save_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_is_save_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_is_save_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_selected_paths_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_selected_paths_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_current_name_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_current_name_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_current_name_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_current_name_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm_interface_fileselector>)
{
   return (ELM_INTERFACE_FILESELECTOR_INTERFACE);
}

} } }

/// @endcond

